#ifndef forward_h
#define forward_h

void move1(int speed, int ang, int k = 1) {
    static uint32_t timer_gate;
    static int gate_x;
    int error = 0;
    pixy.ccc.getBlocks(false);
    error = int(gyro.read() * 3);
    if (pixy.ccc.numBlocks) {
        timer_gate = millis();
        gate_x = pixy.ccc.blocks[0].m_x;
    }
    if (millis() - timer_gate < 600) {
        if (abs(error) < 50)
            error = int(157.5 - gate_x) * k;
        else error = int(gyro.read());
    }
    A.start(-speed * cos((ang - 135) * RAD) + error);
    B.start(-speed * cos((ang + 135) * RAD) + error);
    C.start(-speed * cos((ang + 45) * RAD) + error);
    D.start(-speed * cos((ang - 45) * RAD) + error);
}

int angle() {
    int dir = locator.getDir1200();
    float k = 1;
    if (abs(dir) >= 140 && seeker.getDir600() == 0)
        dir = 170 * dir / abs(dir);
    else if (abs(dir) >= 140 && seeker.getDir1200() != 0)
        dir = 0;
    if (abs(dir) <= 13)
        dir = 0;
    else if (abs(dir) <= 30)
        k = 1.35;
    else if (abs(dir) <= 60)
        k = 2.6;
    else if (abs(dir) <= 130)
        dir = 150 * dir / abs(dir);
    else
        dir = 170 * -dir / abs(dir);
    filterDirection.in(dir * k);
    return filterDirection.out();
}


int sensors() {
    int res = 0;
    static int last;
    static uint32_t tmr;
    for (int i = 0; i < 4; i++) {
        digitalWrite(33, i % 2);
        digitalWrite(35, int(i / 2) % 2);
        if (analogRead(A0) > 800) res |= 1;
        if (analogRead(A1) > 800) res |= 2;
        if (analogRead(A2) > 800) res |= 8;
        if (analogRead(A3) > 800) res |= 4;
    }
    if (res != 0) {
        tmr = millis();
        last = res;
    }
    if (millis() - tmr < 300) return last;
    else return res;
}

void forward()
{
    static int button = 0;
    static int first;
    static uint32_t timer;
    Serial.println(gyro.read());
    if (digitalRead(9) && timer + 2000 < millis()) {
        while (digitalRead(9));
        button = (button + 1) % 2;
        timer = millis();
    }
    if (digitalRead(13)) {
        while (digitalRead(13));
        Serial3.write(1);
    }
    if (button) {
        digitalWrite(10, HIGH);
        digitalWrite(4, HIGH);
        int sens = sensors();
        if (sens == 0) {
            ledL.off();
            uint32_t t = millis();
            int ang = angle();
            while (millis() - t < 20) move1(360, ang, 2);
        }
        else {
            ledL.on();
            int side;
            if (sens & 1) side = 90;
            else if (sens & 4) side = -90;
            else if (sens & 2) side = 180;
            else if (sens & 8) side = 0;
            uint32_t t = millis();
            int a = gyro.read();
            while (millis() - t < 250 && sensors() != 0) move1(200, 180 + side - a);
        }
    }
    else {
        digitalWrite(10, LOW);
        digitalWrite(4, LOW);
    }
}


#endif /* forward_h */
