#ifndef sensors_h
#define sensors_h

NewPing sonar[SONAR_NUM] = {     // Sensor object array.
    NewPing(41, 43, MAX_DISTANCE), // left
    NewPing(30, 31, MAX_DISTANCE), // back
    NewPing(48, 47, MAX_DISTANCE)  // right
};

int line()
{
    digitalWrite(33, LOW);
    digitalWrite(35, LOW);
    
    int a0 = 0, a1 = 0, a2 = 0, a3 = 0;
    if (analogRead(A0) > GREY)
        a0 = a0 | 1;
    if (analogRead(A1) > GREY)
        a1 = a1 | 1;
    if (analogRead(A2) > GREY)
        a2 = a2 | 1;
    if (analogRead(A3) > GREY)
        a3 = a3 | 1;
    
    
    digitalWrite(33, LOW);
    digitalWrite(35, HIGH);
    
    if (analogRead(A0) > GREY)
        a0 = a0 | 1;
    if (analogRead(A1) > GREY)
        a1 = a1 | 1;
    if (analogRead(A2) > GREY)
        a2 = a2 | 1;
    if (analogRead(A3) > GREY)
        a3 = a3 | 1;
    
    digitalWrite(33, HIGH);
    digitalWrite(35, LOW);
    
    if (analogRead(A0) > GREY)
        a0 = a0 | 1;
    if (analogRead(A1) > GREY)
        a1 = a1 | 1;
    if (analogRead(A2) > GREY)
        a2 = a2 | 1;
    if (analogRead(A3) > GREY)
        a3 = a3 | 1;
    
    digitalWrite(33, HIGH);
    digitalWrite(35, HIGH);
    
    if (analogRead(A0) > GREY)
        a0 = a0 | 1;
    if (analogRead(A1) > GREY)
        a1 = a1 | 1;
    if (analogRead(A2) > GREY)
        a2 = a2 | 1;
    if (analogRead(A3) > GREY)
        a3 = a3 | 1;
    
    
    int value = a3 * 8 + a1 * 4 + a0 * 2 + a2;
    if (a3 != 0 || a0 != 0)
    {
        last_line = value;
    }
    return value;
    
}

void echoCheck() { // If ping received, set the sensor distance to array.
    if (sonar[currentSensor].check_timer())
        cm[currentSensor] = sonar[currentSensor].ping_result / US_ROUNDTRIP_CM;
}

void distance()
{
    for (uint8_t i = 0; i < SONAR_NUM; i++) { // Loop through all the sensors.
        //Serial.println(i);
        if (millis() >= pingTimer[i]) {         // Is it this sensor's time to ping?
            pingTimer[i] += PING_INTERVAL * SONAR_NUM;  // Set next time this sensor will be pinged.
            if (i == 0 && currentSensor == SONAR_NUM - 1)
            {
                // Sensor ping cycle complete, do something with the results
                for (uint8_t i = 0; i < SONAR_NUM; i++)
                {
                    dis[i] = cm[i];
                }
                
            }
            sonar[currentSensor].timer_stop();          // Make sure previous timer is canceled before starting a new ping (insurance).
            currentSensor = i;                          // Sensor being accessed.
            cm[currentSensor] = 0;                      // Make distance zero in case there's no ping echo for this sensor.
            sonar[currentSensor].ping_timer(echoCheck); // Do the ping (processing continues, interrupt will call echoCheck to look for echo).
        }
    }
}

void stop()
{
    A.start(0);
    B.start(0);
    C.start(0);
    D.start(0);
}


#endif /* sensors_h */
